<?php
/** Zend_Controller_Action */
//require_once 'Zend/Controller/Action.php';

/**
 * The purpose of the Ka-Map controller is to avoid any need
 * for modifying Ka-Map's code base, which must has been placed
 * in unmodified form in the /kamap folder.
 */

class KamapController extends Zend_Controller_Action
{
	public function init()
	{
		$this->config = Zend_Registry::get("config");
		$this->_helper->viewRenderer->setNoRender(true);
	}
		
// 		public function __call($f, $v)
// 		{
// 			
// 			$path = $this->config->BaseDir.$this->getRequest()->getPathInfo();
// 			
// 			// Make sure the path is a real path (e.g., with no ..'s in it), and the file exists
// 			if (realpath($path) == $path && file_exists($path))
// 			{
// 				if ($this->config->minify)
// 				{
// 					$min = new Minify();
// 					$min->useServerCache($this->config->tmpDir);
// 					$min->serve(
// 						'Files',
// 						array(
// 							'files' => array($this->config->BaseDir."/html".$this->getRequest()->getPathInfo()),
// 							'encodeOutput' => false, //Don't let it encode the output - we're already doing this.
// 						)
// 					);
// 				}
// 				else
// 				{
// 					header("Content-type: application/javascript");
// 					echo file_get_contents($this->config->BaseDir."/html".$this->getRequest()->getPathInfo());
// 				}
// 			}
// 			else
// 			{
// 				throw new MapChat_Exception("Invalid request");
// 			}
// 		}


	/**
	 * The default action for the Ka-Map controller will be
	 * to return a minified/gzipped JavaScript document containing
	 * the base code required for the Ka-Map interface.
	 */
	public function indexAction()
	{
//		$kaDir = $this->config->BaseDir."/kamap/htdocs/";
		$kaDir = $this->config->BaseDir."/html/js/kamap/";
		
		$kaScripts = array(
			$kaDir."DHTMLapi.js",
//			$kaDir."excanvas.js",
			$kaDir."wz_dragdrop.js",
//			$kaDir."wz_jsgraphics.js",
			$kaDir."xhr.js",
			$kaDir."kaMap.js",
			$kaDir."kaTool.js",
			$kaDir."kaZoomer.js",
//			$kaDir."XMLOverlay/kaXmlOverlay.js",
		);
		
		if ($this->config->minify)
		{
			$min = new Minify();
			$min->useServerCache($this->config->tmpDir);
			$min->serve(
						'Files',
						array(
							'files' => $kaScripts,
							'encodeOutput' => false, //Don't let it encode the output - we're already doing this.
						)
					);
		}
		else
		{
			foreach ($kaScripts as $id => $s)
			{
				$kaScripts[$id] = "/* file: ".$s." */\n".file_get_contents($s);
			}
			header("Content-type: application/javascript");
			echo implode("\n",$kaScripts);
		}
	}
	
	/**
	 * Allow Ka-Map scripts to be loaded individually if necessary:
	 */
	public function __call($f, $v)
	{
		$path = $this->config->BaseDir.$this->getRequest()->getPathInfo();
		
		// Make sure the path is a real path (e.g., with no ..'s in it), and the file exists
		if (realpath($path) == $path && file_exists($path))
		{
			if ($this->config->minify)
			{
				$min = new Minify();
				$min->useServerCache($this->config->tmpDir);
				$min->serve(
					'Files',
					array(
						'files' => array($this->config->BaseDir.$this->getRequest()->getPathInfo()),
						'encodeOutput' => false, //Don't let it encode the output - we're already doing this.
					)
				);
			}
			else
			{
				header("Content-type: application/javascript");
				echo file_get_contents($this->config->BaseDir.$this->getRequest()->getPathInfo());
			}
		}
		else
		{
			throw new MapChat_Exception("Invalid request");
		}
	}
	
	/**
	 * Run the substitute method for Ka-Map's init.php:
	 */
	public function initAction()
	{
		MapChat_Session::startSession();
		header("Content-type: application/javascript");
		echo MapChat_KaMap_Init::init();
	}
	
	/**
	 * Run the subtitute method for Ka-Map's tile.php:
	 */
	public function tileAction()
	{
		MapChat_Session::startSession();
		MapChat_KaMap_Tile::getTile();
	}

  /**
	 * Run the subtitute method for Ka-Map's tile_nocache.php:
	 */
	public function tilenocacheAction()
	{
		MapChat_Session::startSession();
		MapChat_KaMap_TileNocache::getTile();
	}

}

?>