<?php
/** Zend_Controller_Action */
//require_once 'Zend/Controller/Action.php';

class SetupController extends Zend_Controller_Action
{
	public function init()
	{
		// Don't let this controller do anything for anyone but local connections.
		if (!in_array($_SERVER["REMOTE_ADDR"],array("127.0.0.1","::1")))
		{
			exit("Error: Remote access not allowed for setup.  Either manually setup the database & configuration for MapChat, or run this setup from a browser located on the same machine as the web server.");
		}
		MapChat_Setup::checkDB();
	}
	
	public function indexAction()
	{
		// Just render the index view...
	}
	
	public function runAction()
	{
		$this->_helper->viewRenderer->setNoRender(true);
		try
		{
			MapChat_Setup::runSetup($this->getRequest()->getParams());
			echo("Database setup is done. <a href=\"../\">Back to MapChat Home.</a>");
		}
		catch (MapChat_Exception $e)
		{
			exit("Error (".$e->getError()."): ".$e->getMessage());
		}
		catch (Exception $e)
		{
			exit("Error (".$e->getCode()."): ".$e->getMessage());
		}
	}
}

?>