/**
 * Launches the Select/Draw dialog with the select options displayed...
 *
 * @class MapChat.SpatialTools.Launcher
 *
 * Depends:
 *	kaMap.js
 *	MapChat.js
 *	MapChat/application.js
 */

// Get an alias for the the MapChat.SpatialTools namespace (to make the code shorter).
var mcst = MapChat.UseNS("MapChat.SpatialTools");

mcst.Launcher = function(options)
{
	var t = this,
		options = (t.options = options||{map:MapChat.map}),
		map = (t.map = options.map),
		mode = (t.mode = options.mode),
		name = (t.name = "Selector"),
		dialogOpts = (t.dialogOpts = options.dialogOpts||{}),
		stDialog = (t.stDialog = MapChat.MapSingleton(["MapChat.SpatialTools.Dialog",['ui.dialog','ui.tabs','jquery.tooltip','jquery.autocomplete']],map));
	
	kaTool.apply( this, [map] );
	
	/** get all the prototype functions from the kaTool object */
	for (var p in kaTool.prototype) {
		if (!mcst.Launcher.prototype[p])
			mcst.Launcher.prototype[p]= kaTool.prototype[p];
	}
	
	
	
	return t;
}

mcst.Launcher.prototype.activate = function()
{
	var t = this, o = t.options;
	MapChat.QueueEvent(8,"SpatialTools",["Launcher",o.mode]);
	t.stDialog.activate(o.mode,o.dialogOpts);
}

mcst.Launcher.prototype.deactivate = function()
{
	this.stDialog.deactivate();
}

