// // Temporary fix for the window hight (for Opera).
// var height_ = jQuery.fn.height;
// jQuery.fn.height = function() {
// 	if ( this[0] == window && jQuery.browser.opera && jQuery.browser.version >= 9.50)
// 		return window.innerHeight;
// 	else return height_.apply($(this[0]));
// };
	
MapChat.StartApplication = function()
{
	$("#IntroPanel").fadeOut(100,function(){
		initDHTMLAPI();
		SET_DHTML();
		$("body").css("overflow","hidden");
		$("#MapChat").addClass("viewport");
		$("#MapChat").append('<div id="mcLogo"><img src="images/splash-sm.png" width="150" height="35" border="0"></div>');
		
		// The kaTool redirect onkeypress doesn't let keypress events to go infotools - this should fix it:
		kaTool_redirect_onkeypress = function (e) {
			if (document.kaCurrentTool) {
				kaMap_onkeypress.apply(document.kaCurrentTool,[e]);
			}
		};
		
		// Similarly, this event is causing problems, where the default function is killing any keypress events:
		kaTool.prototype.onmouseout = function(e) {
			return false;
		};
		
		// This should eventually be replaced with its own class that extends the kaMap object with 
		// the necessary additions for MapChat:
		MapChat.map = new kaMap( 'MapChat' );
		
		// This will be the context that is search for triggering various events:
		MapChat.map.context = $([]);
		
		// This will be where events that relate to the map can be triggered.
		MapChat.map.events = $({});
		
		// Add a toolGroups object - a common object for referencing tools that affect the map by group name.  Anything that
		// actually interacts with the map should belong to the 'nav' group - all other tools that essentially just listen
		// for events on the map can belong to any other group name:
		MapChat.map.toolGroups = {};
		
		// IE7 supports alpha channels in PNG images - this will prevent ka-Map's ie_hack
		// from being applied in IE7+:
		MapChat.map.isIE4 = ($.browser.msie && $.browser.version<7);
		
		MapChat.map.init = "kamap/init?"+(MapChat.useCookies?"":"sid="+MapChat.session.sid);
		MapChat.nav = new kaNavigator( MapChat.map );
		MapChat.nav.activate();
		MapChat.map.defaultTool = MapChat.nav;
		MapChat.zoomer = new kaZoomer(MapChat.map); 
		MapChat.SizePage();
		MapChat.map.registerForEvent( KAMAP_INITIALIZED, null, MapChat.MapSetup );
		
		MapChat.map.registerForEvent( KAMAP_TILES_LOADING, {map:MapChat.map}, MapChat.IndicateTilesLoading );
		
		MapChat.map.registerForEvent( KAMAP_MAP_CLICKED, null, MapChat.BlurProtected );
		
		// Add mouseenter/mouseleave events.
		$(MapChat.map.domObj).bind('mouseenter',function(e){MapChat.kaMap_toolEvent(e,MapChat.map,'mouseenter');});
		$(MapChat.map.domObj).bind('mouseleave',function(e){MapChat.kaMap_toolEvent(e,MapChat.map,'mouseleave');});
		
		MapChat.map.initialize();
		
		MapChat.map.extentHistory = [];
		
		MapChat.map.registerForEvent(KAMAP_EXTENTS_CHANGED,MapChat.map,function(){
			var extent = this.getGeoExtents();
			
			// Make sure we aren't going backwards in the extent history first...
			if (!this.extentHistoryGOTO)
			{
				if (this.extentHistory.length==0)
				{
					this.extentHistory.push(extent);
				}
				else if ($.toJSON(this.extentHistory[this.extentHistory.length-1])!=$.toJSON(extent))
				{
					MapChat.QueueEvent(2,"map extent",extent,MapChat.map);
					this.extentHistory.push(extent);
				}
			}
			
			// Odds are this is triggered by the previous extent tool, so the extent won't be recorded, but remove the GOTO value:
			else
			{
// 				if (this.extentHistoryGOTO!=$.toJSON(extent))
// 				{
					this.extentHistoryGOTO = F;
// 					this.extentHistory.push(extent);
// 				}
			}
			
			// Prevent an infinitely growing extent history:
			if (this.extentHistory.length>50) this.extentHistory.shift();
		});
		
		$(window).resize(MapChat.SizePage);
	});	
}

MapChat.SizePage = function()
{
	var browserWidth = $(window).width(),
		browserHeight = $(window).height(),
		mc = $("#MapChat");
	
	if (browserWidth!=mc.width() || browserHeight!=mc.height())
	{
		mc.css({width:browserWidth,height:browserHeight});
		MapChat.map.resize();
	}
}

/**
 * Returns a common instance of a specific Class object type for a given ka-Map API object.  This
 * will work for class objects that accept map as the first argument, and optionally an options object
 * as the second argument for its constructor function.
 *
 * @param string cls - the name (or array with first element being the name) of the class object.
 * @param object map - the ka-Map API object.
 * @param array cargs - an array of parameters that may be passed as arguments to the class constructor function.
 */
MapChat.MapSingleton = function(cls,map,cargs)
{
	$.blockUI();
	if (typeof(cls)=="string") cls = [cls,null];
	var classname = cls[0];
	args = [map]
	if (typeof(cargs)=="object") args = args.concat(cargs);
	cls.push(args);
	
	if (!map[classname])
	{
		try
		{
			var oClass = new MapChat.Class(cls);
		}
		catch (e)
		{
			MapChat.Debug(["error","Unable to load class:",cls,e]);
			return;
		}
		if (oClass) map[classname] = oClass;
	}
	$.unblockUI();
	return map[classname];
}

// aliases for compatibility with older functions:
MapChat.MapClassObject = MapChat.getMapClassObject = MapChat.MapSingleton;

MapChat.MapSetup = function()
{
	MapChat.menu = new MapChat.Class("MapChat.MapMenu",MapChat.map, MapChat.xmlText(MapChat.discussion.config.find("menu:first").find("div:first")[0]));
	MapChat.menu.activate();
	
	// Use this as a default the drawing canvas for chat, etc.
	MapChat.map.defaultCanvas = MapChat.Class("MapChat.Canvas",{map:MapChat.map,zIndex:600});
	
	// Queue an event with the initial extents...
	MapChat.QueueEvent(2,"Start Extent",MapChat.map.getGeoExtents(),MapChat.map);
	
	if ($.browser.msie) document.onkeydown = kaTool_redirect_onkeypress;
	else document.onkeypress = kaTool_redirect_onkeypress;
	
	// Add the map to the chat module so that it will get updated with map-related events from the chat discussion.
	MapChat.chat.AddMap(MapChat.map);
	
	MapChat.chat.Init();
	
	$.unblockUI();
}

/**
 * Pulsates the mapchat logo as long as there are tiles loading.
 */
MapChat.IndicateTilesLoading = function()
{
// 	var self = this;
// 	if (self.map.loading)
// 	{
// 		$("#mcLogo").fadeOut(500,function(){
// 			$(this).fadeIn(500,function(){
// 				MapChat.IndicateTilesLoading.apply(self);
// 			});
// 		});
// 	}
}


/**
 * Protects an element from keypress events on the document object.
 *
 * @param object o - the element to protect
 * @param object opts - deprecated if undefined, the 'o' object is protected based on focus,
 *  otherwise, the presence of boolean values named 'mouse' or 'focus' will
 *  determine what events the object is protected from.
 */
MapChat.KeyProtect = function(o)
{
	var sp = function(e){if (e.keyCode!=13) e.stopPropagation();};
	$(o).keydown(sp).keypress(sp).keyup(sp).addClass('mapchat-keyprotect')
	.blur(function(){$(this).removeClass('mapchat-keyprotect');});
}

/**
 * Blurs the focus from any keyprotected elements so that the arrow keys and such
 *  are re-enabled on the map interface:
 */
MapChat.BlurProtected = function()
{
	$(".mapchat-keyprotect").blur();
}

/**
 * Extra kaMap tool function for calling events.
 *
 * @param object e - the event object
 * @param object map - the kamap object to trigger the event on
 * @param string eventName - the name of the event to trigger.
 */
MapChat.kaMap_toolEvent = function(e,map,eventName)
{
	// If there's already a handler for the requested event name, use that...
	if (map[eventName]) map[eventName].call(map,e);
	else if (map["on"+eventName]) map["on"+eventName].call(map,e);
	
	// Handle events (e.g., mouseenter/mouseleave):
	else
	{
		if (map.currentTool)
		{
			var ct = map.currentTool;
			if (ct[eventName]) ct[eventName].call(ct,e);
			else if (ct["on"+eventName]) ct["on"+eventName].call(ct,e);
		}
		$.each(map.aInfoTools,function(){
			if (this[eventName]) this[eventName].call(this,e);
			else if (this["on"+eventName]) this["on"+eventName].call(this,e);
		});
	}
};

/**
 * Returns an array of tile IDs by page-relative pixel coordinates.
 *
 * @param array xy - the x/y page coordinates
 * @param object map - the kamap object to search in.
 * @param string layer - if specified, only the named layer will be searched.
 * @param integer buffer - if specified, an extra padding of this distance is included in the search.
 */
MapChat.FindTiles = function(xy,map,layer,buffer)
{
	if (layer)
		var imgs = $("img",$('div.mapLayer[id="'+layer+'"]',MapChat.map.theInsideLayer));
	else
		var imgs = $("img",$('div.mapLayer',MapChat.map.theInsideLayer));
	
	var b = buffer||0;
	
	var img_ids = [];
	imgs.each(function(){
		var t = $(this);
		var tl = [t.offset().left-b,t.offset().top-b];
		var br = [tl[0]+t.width()+b*2,tl[1]+t.height()+b*2];
		if (xy[0]>=tl[0] && xy[1]>=tl[1] && xy[0]<=br[0] && xy[1]<=br[1])
		{
			img_ids.push(t.attr("id"));
		}
	});
	
	return img_ids;
}

/**
 * Returns an array of tile IDs that fall within a min/max range of pixel coordinates.
 *
 * @param array minxy - the min x/y page coordinates to search for
 * @param array maxxy - the max x/y page coordinates
 * @param object map - the kamap object to search in.
 * @param string layer - if specified, only the named layer will be searched.
 * @param integer buffer - if specified, an extra padding of this distance is included in the search.
 */
MapChat.FindTilesByExtent = function(minxy,maxxy,map,layer,buffer)
{
	// Get the actual min/max extents (could be incorrect depending on the corners used)
	var minx = Math.min(minxy[0],maxxy[0]);
	var maxx = Math.max(minxy[0],maxxy[0]);
	var miny = Math.min(minxy[1],maxxy[1]);
	var maxy = Math.max(minxy[1],maxxy[1]);
	
	if (layer)
		var imgs = $("img",$('div.mapLayer[id="'+layer+'"]',MapChat.map.theInsideLayer));
	else
		var imgs = $("img",$('div.mapLayer',MapChat.map.theInsideLayer));
	
	var b = buffer||0;
	
	var img_ids = [];
	imgs.each(function(){
		var t = $(this);
		var tl = [t.offset().left-b,t.offset().top-b];
		var br = [tl[0]+t.width()+b*2,tl[1]+t.height()+b*2];
		
		if ((minx>=tl[0] && miny>=tl[1] && maxx<=br[0] && maxy<=br[1])|| // range is contained by image
			(minx<=tl[0] && miny<=tl[1] && maxx>=br[0] && maxy>=br[1])|| // image is contained by range
			(minx<=tl[0] && miny<=tl[1] && maxx>=tl[0] && maxy>=tl[1])|| // tl of image is in range
			(minx<=br[0] && miny<=tl[1] && maxx>=br[0] && maxy>=tl[1])|| // tr of image is in range
			(minx<=tl[0] && miny<=br[1] && maxx>=tl[0] && maxy>=br[1])|| // bl of image is in range
			(minx>=tl[0] && miny>=tl[1] && minx<=br[0] && miny<=br[1])|| // tl of range is in image
			(maxx>=tl[0] && miny>=tl[1] && maxx<=br[0] && miny<=br[1])|| // tr of range is in image
			(minx>=tl[0] && maxy>=tl[1] && minx<=br[0] && maxy<=br[1])|| // bl of range is in image
			(minx<=tl[0] && maxx>=br[0] && miny>=tl[1] && maxy<=br[1])|| // top/bottom of image is within range height, but image is wider than range
			(minx>=tl[0] && maxx<=br[0] && miny<=tl[1] && maxy>=br[1]) // left/right of image is within range width, but image is taller than range
		)
		{
			img_ids.push(t.attr("id"));
		}
	});
	
	return img_ids;
}


/**
 * Rounds a number to the precision specified in the discussion config.
 *
 * @param mixed n - either a number or an array of numbers.
 */
MapChat.Round = function(n)
{
	try
	{
		var p = 1*$("precision",MapChat.discussion.config).text();
	}
	catch (e)
	{
		var p = 0;
	}
	
	if (typeof(n)=="number") { n = [n]; var r1 = true; }
	
	var r = [];
	$.each(n,function(){
		r.push(Math.round(Math.pow(10,p)*this)/Math.pow(10,p));
	});
	
	return (r1?r[0]:r);
}

/**
 * Adds contexts within which elements will be search when triggering events:
 *
 * @param object map - the map that this context will be added to.
 * @param jQuery c - a jQuery object with the desired context selected.
 */
MapChat.AddContext = function(map,c)
{
	map.context = $($.unique($.merge(map.context.get(),c.get())));
}

// Each tool (or group of tools) will add to this namespace:
MapChat.mcTools = {};
