/**
 * Force currently visible layer groups to refresh themselves.
 *
 * @class MapChat.mcTools.Refresh
 *
 * Depends:
 *	kaMap.js
 *	MapChat.js
 *	MapChat/application.js
 */

$.extend(MapChat.mcTools,{
	Refresh: function(options)
	{
		var t = this,
			options = (t.options = options),
			map = (t.map = options.map),
			name = (t.name = "Refresh");
		
		MapChat.mcTools.Refresh.prototype.activate = function(e)
		{
			MapChat.QueueEvent(3,"RefreshLayers");
			
			t.map.context.trigger("MapRefreshing");
			
			if (e && (e.metaKey||e.shiftKey))
			{
				$.each(t.map.getCurrentMap().aLayers,function(){
					if (t.visible)
					{
						// If the user is holding ctrl or shift, then redraw the layers on the server...
						t.tileSource = 'redraw';
						t.redrawInterval = 1;
						t.setTileLayer(true);
					}
				});
			}
			else
			{
				// Otherwise, just redraw from the client-side (i.e., recreate the image objects).
				map.setMapLayers();
				map.initializeLayers(1);
			}
			
			t.map.context.trigger("MapRefreshed");
		}
		
		return t;
	}
});
