/**
 * A point zoom-out tool.
 *
 * @class MapChat.mcTools.ZoomOut
 *
 * Depends:
 *	kaMap.js
 *	MapChat.js
 *	MapChat/application.js
 */

$.extend(MapChat.mcTools,{
	ZoomOut: function(options)
	{
		var self = this,
			options = (this.options = options),
			map = (this.map = options.map),
			cursor = (this.cursor = "crosshair"),
			name = (this.name = "ZoomOut");
		
		kaTool.apply( this, [map] );
		
		/** get all the prototype functions from the kaTool object */
		for (var p in kaTool.prototype) {
			if (!MapChat.mcTools.ZoomOut.prototype[p])
				MapChat.mcTools.ZoomOut.prototype[p]= kaTool.prototype[p];
		}
		
		return this;
	}
});

/**
 * MapChat.mcTools.ZoomOut.onmouseup( e )
 *
 * called when a mouse button is clicked over theInsideLayer.
 */
MapChat.mcTools.ZoomOut.prototype.onmouseup = function(e) {
	e = $.event.fix(e?e:event);
	if (e.button==2||e.metaKey||e.shiftKey)
	{
		return this.cancelEvent(e);
	}
	else
	{
		var p = this.adjustPixPosition( e.pageX, e.pageY );
		var c = this.map.pixToGeo( p[0], p[1] )
		this.map.zoomOut();
		this.map.zoomTo(c[0],c[1]);
		MapChat.QueueEvent(3,"ZoomOut",["point",c[0],c[1]]);
	}
	return false;
};
