/**
 * Zooms to the previous extent in the map extentHistory
 *
 * @class MapChat.mcTools.ZoomPrevious
 *
 * Depends:
 *	kaMap.js
 *	MapChat.js
 *	MapChat/application.js
 */

MapChat.mcTools.ZoomPrevious = function(options)
{
	var t = this,
		options = (t.options = options),
		map = (t.map = options.map),
		name = (t.name = "ZoomPrevious");
	
	t.activate = function()
	{
		// If there's only one extent in the history, then we're already at it.
		if (t.map.extentHistory.length>1)
		{
			// pop the current extent off:
			t.map.extentHistory.pop();
			// Now well get the previous extent
			var ex = t.map.extentHistory[t.map.extentHistory.length-1];
			
			t.map.extentHistoryGOTO = $.toJSON(ex);
			MapChat.QueueEvent(3,"ZoomPrevious",ex);
			t.map.zoomToExtents(ex[0],ex[1],ex[2],ex[3]);
		}
	}
	
	return this;
}
