MapChat.mcadmin = {/*loadedReqs: false*/};

MapChat.RegisterScript("ui.core","js/jquery/ui/ui.core.js");
MapChat.RegisterScript("ui.draggable","js/jquery/ui/ui.draggable.js",["ui.core"]);
MapChat.RegisterScript("ui.resizable","js/jquery/ui/ui.resizable.js",["ui.core"]);
MapChat.RegisterScript("ui.dialog","js/jquery/ui/ui.dialog.js",["ui.draggable","ui.resizable"]);

MapChat.mcadmin.showManager = function(api)
{
	$.blockUI();
	
	MapChat.Using("ui.dialog");
	
	var manager = MapChat.RunFunction(api+"_Manager");
	var d = $($(manager).find("html:first").text());
	
	d.api = api;
	
	// Bind events to radio inputs if the user has privileges for both create & edit modes:
	d.find("input[type='radio'][name='mode']").click(function(){MapChat.mcadmin.checkForm(d);});
	
	// Bind event to the edit select box for retrieving
	d.find("select[name='Edit_"+d.api+"']").change(function(){MapChat.mcadmin.getSelected(d);});
	
	// Bind the members button:
	d.find("input[type='button'][value='Edit Members']").click(function(){MapChat.mcadmin.listMembers(d);});
	
	// Bind the apply button:
	d.find("input[type='button'][value='Apply']").click(function(){MapChat.mcadmin.sendInfo(d);});
	
	d.dialog({title:"Manage "+api,width:350,height:250,modal:true,
		overlay:{backgroundColor:"white",opacity:.3},
// 		resize:function()
// 		{
// 			// Make the content fit to the dialog's dimensions (so we get scrolling):
// 			var dlg = d.parents(".ui-dialog:first");
// 			d.height($(".ui-resizable-s", dlg).offset().top-d.offset().top);
// 		},
		close:function()
		{
			if (d.m)
			{
				d.m.dialog("destroy");
			}
			d.dialog("destroy");
		}
	});
	
// 	// Make the content fit to the dialog's dimensions (so we get scrolling):
// 	var dlg = d.parents(".ui-dialog:first");
// 	d.height($(".ui-resizable-s", dlg).offset().top-d.offset().top);
		
	MapChat.mcadmin.d = d;
	
	$.unblockUI();
}

MapChat.mcadmin.getSelected = function(d)
{
	$.blockUI();
	
	if (d.m)
	{
		d.m.dialog("destroy");
		d.m = false;
	}
	
	d.find("input[type='text']").val("");
	d.find("input[type='password']").val("");
	d.find("input[type='checkbox']").attr("checked",false);
	
	var edit = d.find("select[name='Edit_"+d.api+"']").find("option:selected").val();
	var info = MapChat.RunFunction(d.api+"_Info",{'args[0]':edit});
	var content = $.parseJSON($(info).find("info").text());
	
	$.each(content,function(i,val){
		var elem = d.find("[name='"+i+"']");
		if (elem[0]) 
		{
			switch (elem[0].nodeName.toUpperCase())
			{
				case "INPUT":
					switch (elem.attr("type").toLowerCase())
					{
						case "text":
							elem.val(val);
							break;
							
						case "password":
							elem.val("");	
							break;
							
						case "checkbox":
						case "radio":
							elem.attr("checked",val);
							break;
					}
					break;
				
				case "TEXTAREA":
					elem.val(val);
					break;	
				
				case "SELECT":
					elem.find("option[value='"+val+"']").attr("selected",true);
					elem.change();
					break;
			}
		}
	});
	
	var sel = d.find("select[name='moderator']");
	if (sel.length>0)
	{
		sel.find("option.tempMod").remove();
		var moderator = $(info).find("moderator");
		if (sel.find("option[value='"+moderator.attr("id")+"']").length>0)
		{
			sel.val(moderator.attr("id"));
		}
		else
		{
			sel.append('<option value="'+moderator.attr("id")+'" selected="true" class="tempMod">'+moderator.text()+'</option>');
		}
	}
	
	$.unblockUI();
}


MapChat.mcadmin.checkForm = function(d)
{
	var createMode = d.find("input[type='radio'][value='Create']").attr("checked");
	createInput = d.find("input[name='Create_"+d.api+"']");
	createInput.attr("disabled",!createMode);
	d.find("select[name='Edit_"+d.api+"']").attr("disabled",createMode);
	
	d.find("input[type='text']").val("");
	d.find("textarea").val("");
	d.find("input[type='password']").val("");
	d.find("input[type='checkbox']").attr("checked",false);
	
	if (d.m)
	{
		d.m.dialog("destroy");
		d.m = false;
	}
	
	if (!createMode && d.find("select[name='Edit_"+d.api+"']")[0].selectedIndex>0)
	{
		MapChat.mcadmin.getSelected(d);
	}
}

MapChat.mcadmin.sendInfo = function(d)
{
	$.blockUI();
	
	var modes = d.find("input[name='mode']");
	if (modes.length>0)
	{
		var mode = d.find("input:checked[name='mode']").val();
	}
	else
	{
		var mode = modes.val();
	}
	
	var args = {"args[0]": d.find("[name='"+mode+"_"+d.api+"']").val()};
	var params = d.find("[id*='"+d.api+"_Manager']");
	var arg = 1;
	params.each(function(){
		var argName = "args["+arg+"]";
		arg++;
		switch (this.nodeName.toUpperCase())
		{
			case "INPUT":
				switch ($(this).attr("type").toLowerCase())
				{
					case "text":
					case "password":
						args[argName] = $(this).val();
						break;
						
					case "checkbox":
					case "radio":
						args[argName] = $(this).attr("checked");
						break;
				}
				break;
			
			case "TEXTAREA":
				args[argName] = $(this).val();
				break;
				
			case "SELECT":
				args[argName] = $(this).val();
				break;
		}
	});
	
	// I was using $.toJSON to encode the user/group member data, but IE was
	// barfing from that...so here I am, coding bunch of stuff to mangle it all
	// into a string:
	var argName = "args["+arg+"]";
	if (d.m)
	{
		var members = {user:[],group:[]};
		d.m.find("input.memberUserCB:checked").each(function(){
			var user = {id:$(this).val()};
			var ro = $(this).nextAll("input.roCB:first");
			if (ro.length>0)
			{
				user.ro = ro.attr('checked');
			}
			members.user.push(user);
		});
		
		d.m.find("input.memberGroupCB:checked").each(function(){
			var group = {id:$(this).val()};
			var ro = $(this).nextAll("input.roCB:first");
			if (ro.length>0)
			{
				group.ro = ro.attr('checked');
			}
			members.group.push(group);
		});
		
		args[argName] = $.toJSON(members);
	}
	else if (d.api!="User")
	{
		args[argName] = "false";
	}
	
	MapChat.RunFunction(d.api+"_"+mode,args);
	
	$.unblockUI();
}

MapChat.mcadmin.listMembers = function(d)
{
	if (d.m)
	{
		d.m.dialog("open");
	}
	else
	{
		var members = MapChat.RunFunction(d.api+"_Members",{"args[0]":d.find("select[name='Edit_"+d.api+"']").val(),"args[1]":true});
		d.m = $('<div  class="autoscroll" />');
		
		d.m.append('Member Users:<br />');
		
		$.each($(members).find("user"),function(i,val){
			d.m.append('<input type="checkbox" class="memberUserCB" value="'+$(val).attr("id")+'" '+
				($(val).attr("is_member")=="true"?"checked ":"")+'/>'+
				$(val).text()+'<br />');
			if ($(val).attr("is_ro")!=undefined)
			{
				d.m.append('<input type="checkbox" class="roCB" style="margin-left:25px;" value="'+$(val).attr("id")+'" '+
					($(val).attr("is_ro")=="true"?"checked ":"")+'/>readonly<br />');
			}
		});
		
		if ($(members).find("group").length>0)
		{
			d.m.append('<br />Member Groups:<br />');
			
			$.each($(members).find("group"),function(i,val){
				d.m.append('<input type="checkbox" class="memberGroupCB" value="'+$(val).attr("id")+'" '+
					($(val).attr("is_member")=="true"?"checked ":"")+'/>'+
					$(val).text()+'<br />');
				if ($(val).attr("is_ro")!=undefined)
				{
					d.m.append('<input type="checkbox" class="roCB" style="margin-left:25px;" value="'+$(val).attr("id")+'" '+
						($(val).attr("is_ro")=="true"?"checked ":"")+'/>readonly<br />');
				}
			});
		}
		
		
		
		d.m.dialog({title:"Manage "+d.api+" Members",width:350,height:250,modal:true,
			overlay:{backgroundColor:"white",opacity:.0} //,
// 			resize:function()
// 			{
// 				// Make the content fit to the dialog's dimensions (so we get scrolling):
// 				var dlg = d.m.parents(".ui-dialog:first");
// 				d.m.height($(".ui-resizable-s", dlg).offset().top-d.m.offset().top);
// 			}
		});
		
// 		// Make the content fit to the dialog's dimensions (so we get scrolling):
// 		var dlg = d.m.parents(".ui-dialog:first");
// 		d.m.height($(".ui-resizable-s", dlg).offset().top-d.m.offset().top);
	}
}