MapChat.mcuser = {loadedReqs: false};

MapChat.RegisterScript("ui.core","js/jquery/ui/ui.core.js");
MapChat.RegisterScript("ui.draggable","js/jquery/ui/ui.draggable.js",["ui.core"]);
MapChat.RegisterScript("ui.resizable","js/jquery/ui/ui.resizable.js",["ui.core"]);
MapChat.RegisterScript("ui.dialog","js/jquery/ui/ui.dialog.js",["ui.draggable","ui.resizable"]);

MapChat.mcuser.showProfile = function()
{
	$.blockUI();
	
	MapChat.Using("ui.dialog");
	
	var info = $.parseJSON($(MapChat.RunFunction("User_Info",{"args[username]": MapChat.session.user_identity})).find("info").text());
	var p = $('<div class="autoscroll"><form><p style="font-size:.8em;">'+
		'Profile settings for '+(info.full_name?info.full_name+' ('+info.username+')':info.username)+':<br /><br />'+
		'Full name: <input type="text" name="full_name" value="'+(info.full_name?info.full_name:'')+'" style="width:200px;" /><br />'+
		'Email: <input type="text" name="email" value="'+(info.email?info.email:'')+'" style="width:250px;" />'+
		'Organization: <input type="text" name="organization" value="'+(info.organization?info.organization:'')+'" style="width:200px;" /><br />'+
		'Occupation: <input type="text" name="occupation" value="'+(info.occupation?info.occupation:'')+'" style="width:200px;" /><br /><br />'+
		
		'Enter your current password: <input type="password" name="password" style="width:150px;" /><br />'+
		'<input type="submit" value="Apply" /><span class="resultMsg" style="margin-left:10px;color:#090;">&nbsp;</span>'+
		'</p></form></div>');
	
	// TODO: add stuff for leaving/joining groups.
	
	p.find("form").submit(function(){MapChat.mcuser.saveProfile(p);return false;});
	
	p.dialog({title:"Edit Profile",width:350,height:250,modal:true,
		overlay:{backgroundColor:"white",opacity:.0},
		resize:function()
		{
			p.height($(this).height()-$(this).find(".ui-dialog-titlebar").
				height()-$(this).find(".ui-resizable-s").height());
		},
		close:function(){p.dialog("destroy");}
	});
	
	// Make the content element (p) fit to the dialog's dimensions (so we get scrolling):
	var dlg = p.parents(".ui-dialog:first");
	p.height(dlg.height() - $(".ui-dialog-titlebar", dlg).height() - $(".ui-resizable-s", dlg).height());
	
	$.unblockUI();
	
}

MapChat.mcuser.saveProfile = function(p)
{
	$.blockUI();
	
	p.find("span.resultMsg").text("Please wait...");
	
	
	var save = $(MapChat.RunFunction("User_UpdateProfile",{
		"args[full_name]": p.find("input[name='full_name']").val(),
		"args[password]": p.find("input[name='password']").val(),
		"args[email]": p.find("input[name='email']").val(),
		"args[organization]": p.find("input[name='organization']").val(),
		"args[occupation]": p.find("input[name='occupation']").val()
	})).find("msg");
	
	p.find("span.resultMsg").text(save.text());
	
	$.unblockUI();
}

MapChat.mcuser.showPW = function()
{
	$.blockUI();
	
	MapChat.Using("ui.dialog");
	
	var info = $.parseJSON($(MapChat.RunFunction("User_Info",{"args[username]": MapChat.session.user_identity})).find("info").text());
	var p = $('<div class="autoscroll"><form><p style="font-size:.8em;">'+
		'Change password for '+(info.full_name?info.full_name+' ('+info.username+')':info.username)+':<br /><br />'+
		'Old password: <input type="password" name="old_password" style="width:150px;" /><br /><br />'+
		'Enter a new password: <input type="password" name="new_password" style="width:150px;" /><br />'+
		'Confirm new password: <input type="password" name="conf_password" style="width:150px;" /><br /><br />'+
		'<input type="submit" value="Apply" /><span class="resultMsg" style="margin-left:10px;color:#090;">&nbsp;</span>'+
		'</p></form></div>');
	
	// TODO: add stuff for leaving/joining groups.
	
	p.find("form").submit(function(){MapChat.mcuser.savePW(p);return false;});
	
	p.dialog({title:"Edit Profile",width:350,height:200,modal:true,
		overlay:{backgroundColor:"white",opacity:.0},
		resize:function()
		{
			p.height($(this).height()-$(this).find(".ui-dialog-titlebar").
				height()-$(this).find(".ui-resizable-s").height());
		},
		close:function(){p.dialog("destroy");}
	});
	
	// Make the content element (p) fit to the dialog's dimensions (so we get scrolling):
	var dlg = p.parents(".ui-dialog:first");
	p.height(dlg.height() - $(".ui-dialog-titlebar", dlg).height() - $(".ui-resizable-s", dlg).height());
	
	$.unblockUI();
	
}

MapChat.mcuser.savePW = function(p)
{
	if (p.find("input[name='conf_password']").val()==p.find("input[name='new_password']").val())
	{
		$.blockUI();
		
		p.find("span.resultMsg").text("Please wait...");
		
		
		var save = $(MapChat.RunFunction("User_UpdatePW",{
			"args[old_password]": p.find("input[name='old_password']").val(),
			"args[new_password]": p.find("input[name='new_password']").val(),
			"args[conf_password]": p.find("input[name='conf_password']").val()
		})).find("msg");
		
		p.find("span.resultMsg").text(save.text());
		
		$.unblockUI();
	}
	else
	{
		p.find("span.resultMsg").text("The new passwords don't match.");
	}
}
