<?php

class MapChat_API_Chat_SendMessage
{
	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->xml = Zend_Registry::get("XMLResponse");
		$this->config = Zend_Registry::get("config");
		$this->discussion = Zend_Registry::get("discussion");
		$this->me = Zend_Registry::get("me");
	}

	public function SendMessage($message,$parent_id=null)
	{
		// Read-only members cannot send chat messages.
		if ($this->discussion->getReadOnly($this->me)) throw new MapChat_Exception("Insufficient permissions to send chat messages");
		
		$le = $this->discussion->Event_lastEvent(2);
		
		$aChat = array(
			"text"=>$message,
			"username"=>$this->me->username,
			"parent_id"=>$parent_id,
			"type"=>1,
			"extent"=>$le["extent"],
		);
		
		$this->xml->chat_id = $this->discussion->Chat_logMessage($aChat);
		return $this->xml;
	}
}

?>