<?php 

class MapChat_API_Discussion_Create
{
	private $_xml = null;

	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->_xml = Zend_Registry::get("XMLResponse");
		$this->me = Zend_Registry::get("me");
	}
	
	public function Create($discussion,$title,$description,$moderator,$mapfile,$config,$srid,$extent,$disabled,$members)
	{
		// only let logged-in users get this:
		if (Zend_Registry::get("auth")->hasIdentity() && $this->me->canCreateDiscussions())
		{
			$d = new MapChat_Discussion();
			$opts = array("discussion"=>$discussion,"title"=>$title,"description"=>$description,
				"moderator"=>$moderator,"mapfile"=>$mapfile,"config"=>$config,"srid"=>$srid,"disabled"=>$disabled);
			if (strlen($extent))
			{
				$opts["extent"]=$extent;
			}
			$d->create($opts);
			
			if ($members!="false")
			{
				$oMembers = Zend_Json::decode($members);
				foreach ($oMembers["user"] as $member)
				{
					$user = new MapChat_User($member["id"]);
					$d->addMember($user,$member["ro"]);
				}
				
				foreach ($oMembers["group"] as $member)
				{
					$group = new MapChat_Group($member["id"]);
					$d->addMember($group,$member["ro"]);
				}
			}
			
			$this->_xml->result = $d->exists();
			return $this->_xml;
		}
		else
		{
			throw new MapChat_Exception("Unauthorized Access.");
		}
	}
	
}

?>