<?php 

class MapChat_API_Discussion_Info
{
	private $_xml = null;

	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->_xml = Zend_Registry::get("XMLResponse");
	}
	
	public function Info($discussion)
	{
		// only let logged-in users get this:
		if (Zend_Registry::get("auth")->hasIdentity())
		{
			$d = new MapChat_Discussion($discussion);
			$info = $d->getInfo();
			$info["extent"] = $info["extent_text"];
			unset($info["extent_text"]);
			$this->_xml->info = json_encode($info);
			
			$moderator = $d->getModerator();
			if ($moderator->exists())
			{
				$this->_xml->moderator = $moderator->displayName();
				$this->_xml->moderator->addAttribute("id",$moderator->username);
			}
			return $this->_xml;
		}
		else
		{
			throw new MapChat_Exception("Unauthorized Access.");
		}
	}
	
}

?>