<?php 

class MapChat_API_Discussion_Manager
{
	private $_xml = null;

	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->_xml = Zend_Registry::get("XMLResponse");
		$this->me = Zend_Registry::get("me");
	}

	public function Manager()
	{
		if (!($this->me->canCreateDiscussions()||$this->me->canManageDiscussions()))
		{
			throw new MapChat_Exception("Insufficient permissions to view the Discussion Manager dialog.");
		}
		
		// Build a representation of the HTML dialog in XML:
		$html = '<div class="autoscroll"><form><p style="font-size:.8em;">';
		if ($this->me->canCreateDiscussions())
		{
			if ($this->me->canManageDiscussions())
			{
				$html .= '<input type="radio" name="mode" value="Create" checked="true" />';
			}
			else
			{
				$html .= '<input type="hidden" name="mode" value="Create" />';
			}
			$html .= 'Create Discussion: <input type="text" name="Create_Discussion" style="width:150px" /><br />';
		}
		
		if ($this->me->canManageDiscussions())
		{
			if ($this->me->canCreateDiscussions())
			{
				$html .= '<input type="radio" name="mode" value="Edit" />';
			}
			else
			{
				$html .= '<input type="hidden" name="mode" value="Edit" />';
			}
			
			$users = '';
			
			$html .= 'Edit Discussion: <select name="Edit_Discussion" style="width:150px"'.
				($this->me->canCreateDiscussions()?' disabled="true"':'').
				'><option disabled="true" selected="true">--Select Discussion--</option>';
			
			// Get all the users, and list them as options:
			foreach (MapChat_Discussion::listAllDiscussions() as $discussion)
			{
				$html .= '<option value="'.$discussion["discussion"].'">'.
					(strlen($discussion["title"])>0?"(".$discussion["discussion"].") ".$discussion["title"]:$discussion["discussion"]).
					'</option>';
			}
			
			$html .= '</select><br />';
		}
		
		$html .= '<br />Title: <input id="Discussion_Manager_title" type="text" name="title" style="width:250px;" /><br />'.
			'Description: <br /><textarea id="Discussion_Manager_description" name="description" style="width:300px;" rows="3"></textarea><br />'.
			'Moderator: <select id="Discussion_Manager_moderator" name="moderator" style="width:200px;">';
			
		// Get all the users that can moderate groups (either is_admin or can_manage_groups, or is the current user with can_create_groups permission), and list them as options:
		foreach (MapChat_Discussion::listDiscussionModerators($this->me) as $user)
		{
			$html .= '<option value="'.$user["username"].'"'.($user["username"]==$this->me->username?" selected":"").'>'.
				(strlen($user["full_name"])>0?"(".$user["username"].") ".$user["full_name"]:$user["username"]).
				'</option>';
		}
			
		$html .= '</select><br />'.
			'Mapfile (or multiple comma-separated mapfiles): <input id="Discussion_Manager_mapfile" type="text" name="mapfile" style="width:200px;" /><br />'.
			'Config File: <input id="Discussion_Manager_config" type="text" name="config" style="width:200px;" /><br />'.
			'Spatial Reference ID: <input id="Discussion_Manager_srid" type="text" name="srid" style="width:100px;" /><br />'.
			'Extent: <input id="Discussion_Manager_extent" type="text" name="extent" style="width:300px;" /><br />'.
			'Disabled: <input id="Discussion_Manager_disabled" type="checkbox" name="disabled" /><br />'.
			'<input type="button" value="Edit Members" />'.
			'<input type="button" value="Apply" />';
			
		$html .= '</p></form></div>';
		
		$this->_xml->html = $html;
			
		return $this->_xml;
	}
}

?>