<?php

class MapChat_API_Discussion_Members
{
	private $_xml = null;

	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->_xml = Zend_Registry::get("XMLResponse");
		$this->me = Zend_Registry::get("me");
	}
	
	public function Members($discussion,$listall=false)
	{
		// only let logged-in users get this:
		if (Zend_Registry::get("auth")->hasIdentity() && ($this->me->canCreateDiscussions()||$this->me->canManageDiscussions()))
		{
			$this->_xml->addChild("members");
			$discussion = new MapChat_Discussion($discussion);
			if ($listall)
			{
				$Users = $discussion->listUsers(false);
				$roUsers = $discussion->listUsers(false,true);
				$allUsers = MapChat_User::listAllUsers();
				foreach ($allUsers as $user)
				{
					$u = $this->_xml->members->addChild("user",(strlen($user["full_name"])>0?"(".$user["username"].") ".$user["full_name"]:$user["username"]));
					$u->addAttribute("id",$user["username"]);
					$u->addAttribute("is_member",(in_array($user["username"],$Users)?"true":"false"));
					$u->addAttribute("is_ro",(in_array($user["username"],$roUsers)?"true":"false"));
				}
				
				$Groups = $discussion->listGroups();
				$rwGroups = $discussion->listGroups(true);
				$allGroups = MapChat_Group::listAllGroups();
				foreach ($allGroups as $group)
				{
					$g = $this->_xml->members->addChild("group",(strlen($group["description"])>0?"(".$group["groupname"].") ".$group["description"]:$group["groupname"]));
					$g->addAttribute("id",$group["groupname"]);
					$g->addAttribute("is_member",(in_array($group["groupname"],$Groups)?"true":"false"));
					$g->addAttribute("is_ro",(in_array($group["groupname"],$rwGroups)?"true":"false"));
				}
			}
			else
			{
				$Users = $discussion->listUsers(false,NULL,true);
				$roUsers = $discussion->listUsers(false,true,true);
				foreach ($Users as $user)
				{
					$u = $this->_xml->members->addChild("user",(strlen($user["full_name"])>0?"(".$user["username"].") ".$user["full_name"]:$user["username"]));
					$u->addAttribute("id",$user["username"]);
					$u->addAttribute("is_member","true");
					$u->addAttribute("is_ro",(in_array($user["username"],$roUsers)?"true":"false"));
				}
				
				$Groups = $discussion->listGroups(NULL,true);
				$rwGroups = $discussion->listGroups(true,true);
				foreach ($Groups as $group)
				{
					$g = $this->_xml->members->addChild("group",(strlen($group["description"])>0?"(".$group["groupname"].") ".$group["description"]:$group["groupname"]));
					$g->addAttribute("id",$group["groupname"]);
					$g->addAttribute("is_member","true");
					$g->addAttribute("is_ro",(in_array($group["groupname"],$rwGroups)?"true":"false"));
				}
			}
		}
		else
		{
			throw new MapChat_Exception("Unauthorized Access.");
		}
		
		return $this->_xml;
	}
	
}

?>