<?php 
/**
 * The purpose of this script is to deal with HTTPS/HTTP redirections when applicable.
 * When this script is called, load_discussion = <discussion_name> is saved in the session,
 * so that the next page load will know to load the discussion instead.
 */
class MapChat_API_Discussion_Redirect
{
	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->xml = Zend_Registry::get("XMLResponse");
		$this->me = Zend_Registry::get("me");
	}
	
	/*
	 * Make sure the user is a member of the requested discussion, then flag
	 * the session to load the discussion on the next page access.
	 * 
	 * @param string $d the name of the discussion to load:
	 */
	public function Redirect($d)
	{
		// only let logged-in users get this:
		if (Zend_Registry::get("auth")->hasIdentity())
		{
			$oDiscussion = new MapChat_Discussion($d);
			
			if (!($oDiscussion->exists() &&
				$oDiscussion->hasMember($this->me)))
			{
				throw new MapChat_Exception("Unauthorized Access.");
			}
			
			MapChat_Session::ns()->load_discussion = $d;
			
			$this->xml->addChild("success");
			
			return $this->xml;
		}
		else
		{
			throw new MapChat_Exception("Unauthorized Access.");
		}
	}
	
}

?>