<?php

class MapChat_API_Draw_Features
{
	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->xml = Zend_Registry::get("XMLResponse");
		$this->config = Zend_Registry::get("config");
		$this->discussion = Zend_Registry::get("discussion");
		$this->me = Zend_Registry::get("me");
	}

	/**
	 * Draw features
	 * 
	 * @param string $opts - the options that define what to do with feature drawings
	 *
	 * Possible values that can be included in the opts parameter:
	 *  map: the name of the mapfile to query (required)
	 *  cellSize: the client pixel size (required - for snapping?)
	 *  mode: one of 'add', 'cut', 'open', 'list' - defines wither to add new coordinates to the current (or new) drawing,
	 *        cut areas out of a drawing, or list the current selection
	 *  style: one of 'point', 'circle', 'line', 'polygon' - defines how the drawing will be performed
	 *  coords: the coordinates that are to be used to create/update a drawing
	 *  props: properties to assign to a drawing
	 *  id: this should be the id of the drawing to modify (if 'add' or 'cut') or return data for (if 'open')
	 *
	 */
	public function Features($opts=NULL)
	{
		$opts = Zend_Json::decode($opts);
		$draw_results = $this->discussion->Draw_Features($opts);
		$this->xml->draw_results = Zend_Json::encode($draw_results["results"]);
		$this->xml->draw_results->addAttribute("mode",$draw_results["mode"]);
		
		return $this->xml;
	}
}

?>