<?php 

class MapChat_API_Group_Edit
{
	private $_xml = null;

	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->_xml = Zend_Registry::get("XMLResponse");
		$this->me = Zend_Registry::get("me");
	}
	
	public function Edit($groupname,$password,$description,$moderator,$is_admin,$is_public,$can_create_users,$can_manage_users,$can_create_groups,$can_manage_groups,$can_create_discussions,$can_manage_discussions,$members)
	{
		// only let logged-in users get this:
		if (Zend_Registry::get("auth")->hasIdentity() && $this->me->canManageGroups())
		{
			$group = new MapChat_Group($groupname);
			$opts = array("description"=>$description,
				"moderator"=>$moderator,"is_admin"=>$is_admin,"is_public"=>$is_public,"can_create_users"=>$can_create_users,"can_manage_users"=>$can_manage_users,"can_create_groups"=>$can_create_groups,"can_manage_groups"=>$can_manage_groups,"can_create_discussions"=>$can_create_discussions,"can_manage_discussions"=>$can_manage_discussions);
			if (strlen($password)>0)
			{
				$opts["password"]=$password;
			}
			
			// Run through the list of users selected for membership:
			if ($members!="false")
			{
				$aMembers = array();
				$oMembers = Zend_Json::decode($members);
				foreach ($oMembers["user"] as $member)
				{
					$group->addUser($member["id"]);
					$aMembers[] = $member["id"];
				}
			
				// Drop an existing members that weren't in the original user list:
				$aCurMembers = $group->listUsers();
				foreach ($aCurMembers as $member)
				{
					if (!in_array($member,$aMembers))
					{
						$group->dropUser($member);
					}
				}
			}
			$group->setInfo($opts);
			$this->_xml->result = $group->exists();
			return $this->_xml;
		}
		else
		{
			throw new MapChat_Exception("Unauthorized Access.");
		}
	}
	
}

?>
