<?php 

class MapChat_API_Group_Info
{
	private $_xml = null;

	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->_xml = Zend_Registry::get("XMLResponse");
	}
	
	public function Info($groupname)
	{
		// only let logged-in users get this:
		if (Zend_Registry::get("auth")->hasIdentity())
		{
			$group = new MapChat_Group($groupname);
			$this->_xml->info = json_encode($group->getInfo());
			
			$moderator = $group->getModerator();
			if ($moderator->exists())
			{
				$this->_xml->moderator = $moderator->displayName();
				$this->_xml->moderator->addAttribute("id",$moderator->username);
			}
			return $this->_xml;
		}
		else
		{
			throw new MapChat_Exception("Unauthorized Access.");
		}
	}
	
}

?>