<?php 

class MapChat_API_Group_Manager
{
	private $_xml = null;

	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->_xml = Zend_Registry::get("XMLResponse");
		$this->me = Zend_Registry::get("me");
	}

	public function Manager()
	{
		if (!($this->me->canCreateGroups()||$this->me->canManageGroups()))
		{
			throw new MapChat_Exception("Insufficient permissions to view the Group Manager dialog.");
		}
		
		// Build a representation of the HTML dialog in XML:
		$html = '<div class="autoscroll"><form><p style="font-size:.8em;">';
		if ($this->me->canCreateGroups())
		{
			if ($this->me->canManageGroups())
			{
				$html .= '<input type="radio" name="mode" value="Create" checked="true" />';
			}
			else
			{
				$html .= '<input type="hidden" name="mode" value="Create" />';
			}
			$html .= 'Create Group: <input type="text" name="Create_Group" style="width:150px" /><br />';
		}
		
		if ($this->me->canManageGroups())
		{
			if ($this->me->canCreateGroups())
			{
				$html .= '<input type="radio" name="mode" value="Edit" />';
			}
			else
			{
				$html .= '<input type="hidden" name="mode" value="Edit" />';
			}
			
			$users = '';
			
			$html .= 'Edit Group: <select name="Edit_Group" style="width:150px"'.
				($this->me->canCreateGroups()?' disabled="true"':'').
				'><option disabled="true" selected="true">--Select Group--</option>';
			
			// Get all the users, and list them as options:
			foreach (MapChat_Group::listAllGroups() as $group)
			{
				$html .= '<option value="'.$group["groupname"].'">'.
					(strlen($group["description"])>0?"(".$group["groupname"].") ".$group["description"]:$group["groupname"]).
					'</option>';
			}
			
			$html .= '</select><br />';
		}
		
		$html .= '<br />Password: <input id="Group_Manager_password" type="password" name="password" style="width:150px;" /><br />'.
			'Description: <input id="Group_Manager_description" type="text" name="description" style="width:250px;" /><br />'.
			'Moderator: <select id="Group_Manager_moderator" name="moderator" style="width:200px;">';
			
			// Get all the users that can moderate groups (either is_admin or can_manage_groups, or is the current user with can_create_groups permission), and list them as options:
			foreach (MapChat_Group::listGroupModerators($this->me) as $user)
			{
				$html .= '<option value="'.$user["username"].'"'.($user["username"]==$this->me->username?" selected":"").'>'.
					(strlen($user["full_name"])>0?"(".$user["username"].") ".$user["full_name"]:$user["username"]).
					'</option>';
			}
			
		$html .= '</select><br />'.
			'Is Admin: <input id="Group_Manager_is_admin" type="checkbox" name="is_admin" /><br />'.
			'Is Public: <input id="Group_Manager_is_public" type="checkbox" name="is_public" /><br />'.
			'Can create users: <input id="Group_Manager_can_create_users" type="checkbox" name="can_create_users" /><br />'.
			'Can manage users: <input id="Group_Manager_can_manage_users" type="checkbox" name="can_manage_users" /><br />'.
			'Can create groups: <input id="Group_Manager_can_create_groups" type="checkbox" name="can_create_groups" /><br />'.
			'Can manage groups: <input id="Group_Manager_can_manage_groups" type="checkbox" name="can_manage_groups" /><br />'.
			'Can create discussions: <input id="Group_Manager_can_create_discussions" type="checkbox" name="can_create_discussions" /><br />'.
			'Can manage discussions: <input id="Group_Manager_can_manage_discussions" type="checkbox" name="can_manage_discussions" /><br />'.
			'<input type="button" value="Edit Members" />'.
			'<input type="button" value="Apply" />';
			
		$html .= '</p></form></div>';
		
		$this->_xml->html = $html;
			
		return $this->_xml;
	}
}

?>