<?php

class MapChat_API_Group_Members
{
	private $_xml = null;

	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->_xml = Zend_Registry::get("XMLResponse");
		$this->me = Zend_Registry::get("me");
	}
	
	public function Members($groupname,$listall=false)
	{
		// only let logged-in users get this:
		if (Zend_Registry::get("auth")->hasIdentity() && ($this->me->canCreateGroups()||$this->me->canManageGroups()))
		{
			$this->_xml->addChild("members");
			$group = new MapChat_Group($groupname);
			if ($listall)
			{
				$members = $group->listUsers();
				$users = MapChat_User::listAllUsers();
				foreach ($users as $user)
				{
					$u = $this->_xml->members->addChild("user",(strlen($user["full_name"])>0?"(".$user["username"].") ".$user["full_name"]:$user["username"]));
					$u->addAttribute("id",$user["username"]);
					$u->addAttribute("is_member",(in_array($user["username"],$members)?"true":"false"));
				}
			}
			else
			{
				$members = $group->listUsers(true);
				foreach ($members as $user)
				{
					$u = $this->_xml->members->addChild("user",(strlen($user["full_name"])>0?"(".$user["username"].") ".$user["full_name"]:$user["username"]));
					$u->addAttribute("id",$user["username"]);
					$u->addAttribute("is_member","true");
				}
			}
		}
		else
		{
			throw new MapChat_Exception("Unauthorized Access.");
		}
		
		return $this->_xml;
	}
	
}

?>