<?php 

class MapChat_API_Map_Identify
{
	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->xml = Zend_Registry::get("XMLResponse");
		$this->config = Zend_Registry::get("config");
		$this->discussion = Zend_Registry::get("discussion");
		$this->me = Zend_Registry::get("me");
	}
	
	/**
	 * Return an array of attributes for the features in
	 * a map layer at a given coordinate.
	 *
	 * @param string $map the name of the map that the layer is in
	 * @param string $layer the name of the layer to query for information
	 * @param numeric $x,$y the coordinates to query the layer at.
	 * @param numeric $cellSize the current geographic size of a pixel in
	 *   the client display - so we can set an appropriate tolerance for
	 *   querying features in vector layers.
	 */
	public function Identify($map,$layer,$x,$y,$cellSize)
	{
		$results = $this->discussion->Layer_Identify($map,$layer,$x,$y,$cellSize);
		$this->xml->results = Zend_Json::encode($results);
		$this->discussion->Event_log(array(
			"type"=>5,
			"text"=>"Map_Identify",
			"data"=>array($map,$layer,$x,$y,$cellSize), // might be interesting to parse/log the identify results...
			"username"=>$this->me->username,
		));
		return $this->xml;
	}
}

?>