<?php 

class MapChat_API_Map_LayerProps
{
	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->xml = Zend_Registry::get("XMLResponse");
		$this->config = Zend_Registry::get("config");
		$this->discussion = Zend_Registry::get("discussion");
		$this->me = Zend_Registry::get("me");
	}
	
	/**
	 * Return a JSON-encoded array of map/group/layer information.
	 *
	 * @param string $map the name of the map that the layer is in
	 * @param string $layer the name of the layer to get/set properties on
	 * @param string $props JSON-encoded list of properties to set
	 *   on this layer - if unset, then its current properties are
	 *   returned unmodified:
	 */
	public function LayerProps($map,$layer,$props=false)
	{
		if ($props!==false)
		{
			$this->discussion->Layer_setProps($map,$layer,Zend_Json::decode($props));
		}
		$this->xml->layerprops = Zend_Json::encode($this->discussion->Layer_getProps($map,$layer));
		$this->discussion->Event_log(array(
			"type"=>5,
			"text"=>"Map_LayerProps",
			"data"=>array($map,$layer,$props),
			"username"=>$this->me->username,
		));
		return $this->xml;
	}
}

?>