<?php 
/**
 * Deletes a plan for the current user.
 *
 * @class MapChat_API_Plan_Delete
 *
 */
 
class MapChat_API_Plan_Delete
{
	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->xml = Zend_Registry::get("XMLResponse");
		$this->discussion = Zend_Registry::get("discussion");
		$this->me = Zend_Registry::get("me");
	}
	
	/**
	 * Deletes a plan for the current user.
	 *
	 * @param integer $plan_id - the id of the plan to be deleted.
	 */
	public function Delete($plan_id)
	{
		// Read-only members cannot delete plans.
		if ($this->discussion->getReadOnly($this->me)) throw new MapChat_Exception("Insufficient permissions to delete a plan");
		
		$this->xml->plan_deleted = Zend_Json::encode($this->discussion->Plan_Delete($plan_id));
		$this->discussion->Event_log(array(
			"type"=>4,
			"text"=>"Plan_Delete",
			"data"=>array($plan_id),
			"username"=>$this->me->username,
		));
		return $this->xml;
	}
}

?>