<?php 
/**
 * Deletes a feature information from the plan in the dataabse.
 *
 * @class MapChat_API_Plan_DeleteFeature
 *
 */
 
class MapChat_API_Plan_DeleteFeature
{
	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->xml = Zend_Registry::get("XMLResponse");
		$this->discussion = Zend_Registry::get("discussion");
		$this->me = Zend_Registry::get("me");
	}
	
	/**
	 * Returns a JSON-encoded array of feature information.
	 *
	 * @param integer $plan_id - the id for the user plan to setup
	 * @param integer $layer - the name of the plan layer that the feature belongs to
	 * @param integer $fid - the index of the feature (not the actual id, but it's position in the list of IDs)
	 */
	public function DeleteFeature($plan_id,$layer,$fid)
	{
		// Read-only members cannot delete features.
		if ($this->discussion->getReadOnly($this->me)) throw new MapChat_Exception("Insufficient permissions to delete features");
		
		$this->xml->plan_feature_deleted = $this->discussion->Plan_DeleteFeature($plan_id,$layer,$fid);
		$this->discussion->Event_log(array(
			"type"=>4,
			"text"=>"Plan_DeleteFeature",
			"data"=>array($plan_id,$layer,$fid),
			"username"=>$this->me->username,
		));
		return $this->xml;
	}
}

?>