<?php 
/**
 * Gets a feature's information from the plan in the dataabse.
 *
 * @class MapChat_API_Plan_GetFeature
 *
 */
 
class MapChat_API_Plan_GetFeature
{
	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->xml = Zend_Registry::get("XMLResponse");
		$this->discussion = Zend_Registry::get("discussion");
		$this->me = Zend_Registry::get("me");
	}
	
	/**
	 * Returns a JSON-encoded array of feature information.
	 *
	 * @param integer $plan_id - the id of the plan that hte feature will be saved to.
	 * @param string $layer - the name of the plan layer that the feature is in
	 * @param integer $idx - the feature's index (in sequential order by id) in the layer.
	 */
	public function GetFeature($plan_id,$layer,$idx)
	{
		$featureInfo = $this->discussion->Plan_GetFeature($plan_id,$layer,$idx);
		$this->xml->plan_feature_info = Zend_Json::encode($featureInfo);
		$this->discussion->Event_log(array(
			"type"=>4,
			"text"=>"Plan_GetFeature",
			"data"=>array($plan_id,$layer,$idx,$featureInfo["id"]),
			"username"=>$this->me->username,
		));
		return $this->xml;
	}
}

?>