<?php 
/**
 * Return a list of Plan titles for the user 
 *
 * @class MapChat_API_Plan_Listing
 *
 */
 
class MapChat_API_Plan_Listing
{
	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->xml = Zend_Registry::get("XMLResponse");
		$this->discussion = Zend_Registry::get("discussion");
		$this->me = Zend_Registry::get("me");
	}
	
	/**
	 * Return a JSON-encoded array of plans for the current user.
	 *
	 * @param mixed $type the type of plan to look for (either an integer value, or the
	 *  description value listed in the plan_types lookup table);
	 */
	public function Listing($type)
	{
		$this->xml->plans = Zend_Json::encode($this->discussion->Plan_Listing($type));
		$this->discussion->Event_log(array(
			"type"=>4,
			"text"=>"Plan_Listing",
			"data"=>array($type),
			"username"=>$this->me->username,
		));
		return $this->xml;
	}
}

?>