<?php 
/**
 * Adds layers to a mapfile and returns information for a given user-plan in the discussion.
 *
 * @class MapChat_API_Plan_Open
 *
 */
 
class MapChat_API_Plan_Open
{
	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->xml = Zend_Registry::get("XMLResponse");
		$this->discussion = Zend_Registry::get("discussion");
		$this->me = Zend_Registry::get("me");
	}
	
	/**
	 * Returns the a JSON-encoded array of descriptive information.
	 *
	 * @param integer $plan_id the id of the plan to retrieve information for.
	 * @param string $mapfile the name of the mapfile to add the plan's layer to.
	 */
	public function Open($plan_id,$mapfile)
	{
		$this->xml->plan_id = $plan_id;
		$this->xml->imageformat = $this->discussion->discussion_config->user_imageformat;
		$this->xml->opacity = $this->discussion->discussion_config->user_opacity;
		$this->xml->plan_maplayers = Zend_Json::encode($this->discussion->Plan_Open($plan_id,$mapfile));
		$this->xml->plan_info = Zend_Json::encode($this->discussion->Plan_Info($plan_id));
		$this->xml->plan_feature_counts = Zend_Json::encode($this->discussion->Plan_FeatureCounts($plan_id));
		$this->discussion->Event_log(array(
			"type"=>4,
			"text"=>"Plan_Open",
			"data"=>array($plan_id),
			"username"=>$this->me->username,
		));
		return $this->xml;
	}
}

?>