<?php 
/**
 * Saves features to the plan in the dataabse.
 *
 * @class MapChat_API_Plan_SaveFeature
 *
 */
 
class MapChat_API_Plan_SaveFeature
{
	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->xml = Zend_Registry::get("XMLResponse");
		$this->discussion = Zend_Registry::get("discussion");
		$this->me = Zend_Registry::get("me");
	}
	
	/**
	 * Parses a JSON-encoded array of feature data, and saves it to the plan in the database.
	 *
	 * @param integer $plan_id - the id of the plan that hte feature will be saved to.
	 * @param string $feature - the feature data.
	 */
	public function SaveFeature($plan_id,$feature)
	{
		// Read-only members cannot delete plans.
		if ($this->discussion->getReadOnly($this->me)) throw new MapChat_Exception("Insufficient permissions to save features");
		$featureID = $this->discussion->Plan_SaveFeature($plan_id,Zend_Json::decode($feature));
		
		$this->xml->plan_feature_id = $featureID;
		$this->discussion->Event_log(array(
			"type"=>4,
			"text"=>"Plan_SaveFeature",
			"data"=>array($plan_id,$featureID),
			"username"=>$this->me->username,
		));
		return $this->xml;
	}
}

?>