<?php

class MapChat_API_Select_Features
{
	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->xml = Zend_Registry::get("XMLResponse");
		$this->config = Zend_Registry::get("config");
		$this->discussion = Zend_Registry::get("discussion");
		$this->me = Zend_Registry::get("me");
	}

	/**
	 * Selects features
	 * 
	 * @param string $opts - the options that define what to do with the feature selection
	 *
	 * Possible values that can be included in the opts parameter:
	 *  map: the name of the mapfile to query (required)
	 *  cellSize: the client pixel size (required)
	 *  mode: one of 'add', 'remove', 'clear', 'list' - defines wither to add new features, remove features, clear, or list the current selection
	 *  style: one of 'point', 'circle', 'rectangle', 'by_id' - defines how the selection will be performed
	 *  layer: either the name of a vector layer in the map, or '[All Visible Layers]'
	 *  coords: the coordinates that are to be used to search for features
	 *  ids: if style is 'by_id', and mode is 'remove', this should be a list of ids from the user_selection table to remove
	 *  
	 */
	public function Features($opts=NULL)
	{
		$opts = Zend_Json::decode($opts);
		$select_results = $this->discussion->Select_Features($opts);
		$this->xml->select_results = Zend_Json::encode($select_results["results"]);
		$this->xml->select_results->addAttribute("mode",$select_results["mode"]);
		
		return $this->xml;
	}
}

?>