<?php 

class MapChat_API_User_Info
{
	private $_xml = null;

	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->_xml = Zend_Registry::get("XMLResponse");
	}
	
	/**
	 * Returns the account information for a given user.
	 *
	 * @param string $username - the user id for the user account
	 * @param boolean $unclean - if for whatever reason we don't want
	 *  the user's information cleaned up (e.g., default the display_name,
	 *  and remove the md5-encrypted password), then set this true.
	 */
	public function Info($username,$unclean=false)
	{
		// only let logged-in users get this:
		if (Zend_Registry::get("auth")->hasIdentity())
		{
			if ($unclean)
			{
				$this->_xml->info = Zend_Json::encode($user->getInfo());
			}
			else
			{
				$user = new MapChat_User($username);
				$aInfo = $user->getInfo();
				unset($aInfo["password"]);
				$aInfo["display_name"] = $user->displayName();
				
				// If we are currently in a discussion, report the user's online state for the discussion:
				$d = Zend_Registry::get("discussion");
				if ($d && $d->name!=NULL) $aInfo["online"] = ($d->getOnlineUsers($aInfo["username"],true)?true:false);
				
				$this->_xml->info = Zend_Json::encode($aInfo);
			}
			return $this->_xml;
		}
		else
		{
			throw new MapChat_Exception("Unauthorized Access.");
		}
	}
	
}

?>