<?php 

class MapChat_API_User_ListAll
{
	private $_xml = null;

	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->xml = Zend_Registry::get("XMLResponse");
		$this->config = Zend_Registry::get("config");
		$this->discussion = Zend_Registry::get("discussion");
		$this->me = Zend_Registry::get("me");
	}
	
	/**
	 * Returns a list of all users in the discussion, along with their online states, 
	 *  display states (for user drawings), and colours (for user drawings).
	 *
	 * @param string $mapfile - the mapfile that should be examined to check for users' display states/colors
	 */
	public function ListAll($mapfile)
	{
		// only let logged-in users get this:
		if (Zend_Registry::get("auth")->hasIdentity())
		{
			$this->xml->user_list = Zend_Json::encode($this->discussion->User_ListAll($mapfile));
			return $this->xml;
		}
		else
		{
			throw new MapChat_Exception("Unauthorized Access.");
		}
	}
	
}

?>