<?php 

class MapChat_API_User_Manager
{
	private $_xml = null;

	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->_xml = Zend_Registry::get("XMLResponse");
		$this->me = Zend_Registry::get("me");
	}

	public function Manager()
	{
		if (!($this->me->canCreateUsers()||$this->me->canManageUsers()))
		{
			throw new MapChat_Exception("Insufficient permissions to view the User Manager dialog.");
		}
		
		// Build a representation of the HTML dialog in XML:
		$html = '<div class="autoscroll"><form><p style="font-size:.8em;">';
		if ($this->me->canCreateUsers())
		{
			if ($this->me->canManageUsers())
			{
				$html .= '<input type="radio" name="mode" value="Create" checked="true" />';
			}
			else
			{
				$html .= '<input type="hidden" name="mode" value="Create" />';
			}
			$html .= 'Create User: <input type="text" name="Create_User" style="width:150px" /><br />';
		}
		
		if ($this->me->canManageUsers())
		{
			if ($this->me->canCreateUsers())
			{
				$html .= '<input type="radio" name="mode" value="Edit" />';
			}
			else
			{
				$html .= '<input type="hidden" name="mode" value="Edit" />';
			}
			
			$users = '';
			
			$html .= 'Edit User: <select name="Edit_User" style="width:150px"'.
				($this->me->canCreateUsers()?' disabled="true"':'').
				'><option disabled="true" selected="true">--Select User--</option>';
			
			// Get all the users, and list them as options:
			foreach (MapChat_User::listAllUsers() as $user)
			{
				$html .= '<option value="'.$user["username"].'">'.
					(strlen($user["full_name"])>0?$user["full_name"]:$user["username"]).
					'</option>';
			}
			
			$html .= '</select><br />';
		}
		
		$html .= '<br />Password: <input id="User_Manager_password" type="password" name="password" style="width:150px;" /><br />'.
			'Full name: <input id="User_Manager_full_name" type="text" name="full_name" style="width:200px;" /><br />'.
			'Email: <input id="User_Manager_email" type="text" name="email" style="width:250px;" /><br />'.
			'Organization: <input id="User_Manager_organization" type="text" name="organization" style="width:200px;" /><br />'.
			'Occupation: <input id="User_Manager_occupation" type="text" name="occupation" style="width:200px;" /><br />'.
			'Disabled: <input id="User_Manager_disabled" type="checkbox" name="disabled" /><br />'.
			'<input type="button" value="Apply" />';
			
		$html .= '</p></form></div>';
		
		$this->_xml->html = $html;
			
		return $this->_xml;
	}
}

?>