<?php 

class MapChat_API_User_Register
{
	private $_xml = null;

	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->_xml = Zend_Registry::get("XMLResponse");
		$this->me = Zend_Registry::get("me");
	}
	
	public function Register($username,$full_name,$email,$password,$captcha,$cid,$agree)
	{
		
		if (!$agree)
		{
			$this->_xml->addChild('regerr','agree');
			return $this->_xml;
		}
		
		$checkUser = new MapChat_User($username);
		if ($checkUser->exists())
		{
			$this->_xml->addChild('regerr','username.nametaken');
			return $this->_xml;
		}
		
		if (!MapChat_Captcha::verify($cid,$captcha))
		{
			$this->_xml->addChild('regerr','captcha.mismatch');
			$this->_xml->newcaptcha = MapChat_Captcha::generate();
			return $this->_xml;
		}
		
		$newUser = new MapChat_User();
		
		$newUser->create(array("username"=>$username,"full_name"=>$full_name,"email"=>$email,"password"=>$password),true);
		
		$this->_xml->addChild('success');
		return $this->_xml;
	}
	
}

?>