<?php 

class MapChat_API_User_States
{
	private $_xml = null;

	public function __construct()
	{
		// Load the Response Object from the Api Controller
		$this->xml = Zend_Registry::get("XMLResponse");
		$this->config = Zend_Registry::get("config");
		$this->discussion = Zend_Registry::get("discussion");
		$this->me = Zend_Registry::get("me");
	}
	
	/**
	 * Returns a list of all users in the discussion, along with their online states, 
	 *  display states (for user drawings), and colours (for user drawings).
	 *
	 * @param string $mapfile - the mapfile that should be examined to check for users' display states/colors
	 * @param string $ustates - a JSON-encoded array of user display states/colors
	 */
	public function States($mapfile,$ustates)
	{
		$this->xml->user_states = Zend_Json::encode($this->discussion->User_SetStates($mapfile,Zend_Json::decode($ustates)));
		return $this->xml;
	}
	
}

?>