<?php

// A class for doing stuff with Colors
class MapChat_Color
{

	/**
	 * Convert from rgb to hex.
	 * Taken from http://www.anyexample.com/programming/php/php_convert_rgb_from_to_html_hex_color.xml
	 */
	public function rgb2hex($r, $g=-1, $b=-1)
	{
		if (is_array($r) && sizeof($r) == 3) list($r, $g, $b) = $r;
		$r = intval($r); $g = intval($g);
		$b = intval($b);
		$r = dechex($r<0?0:($r>255?255:$r));
		$g = dechex($g<0?0:($g>255?255:$g));
		$b = dechex($b<0?0:($b>255?255:$b));
		$color = (strlen($r) < 2?'0':'').$r;
		$color .= (strlen($g) < 2?'0':'').$g;
		$color .= (strlen($b) < 2?'0':'').$b;
		return '#'.$color;
	}
	
	/**
	 * Convert from hex to rgb
	 * Taken from http://www.anyexample.com/programming/php/php_convert_rgb_from_to_html_hex_color.xml
	 */
	public function hex2rgb($color)
	{
		if ($color[0] == '#') $color = substr($color, 1);
		if (strlen($color) == 6)
			list($r, $g, $b) = array($color[0].$color[1],$color[2].$color[3],$color[4].$color[5]);
		elseif (strlen($color) == 3)
			list($r, $g, $b) = array($color[0].$color[0], $color[1].$color[1], $color[2].$color[2]);
		else
			return false;
		$r = hexdec($r);
		$g = hexdec($g);
		$b = hexdec($b);
		return array($r, $g, $b);
	}
	
	/**
	 * Creates colours from md5 hashes of an input string.
	 */
	public function makeColor($s,$rgb=false)
	{
		$c = '#'.substr(md5($s),0,6);
		if ($rgb) return MapChat_Color::hex2rgb($c);
		return $c;
	}
}

?>