<?php
/**
 * A plugin that lets the front controller redirect Ka-Map scripts
 * to the appropriate action in the Ka-Map controller:
 */
class MapChat_KaMapRedirector extends Zend_Controller_Plugin_Abstract
{
	public function preDispatch($request)
	{
		$conf = Zend_Registry::get("config");
		$cn = $request->getControllerName();
		
		// Redirect to the Ka-Map controller for any requests for
		// init.php, tile.php, or tile_nocache.php:
		if (in_array($request->getControllerName(),array("tile.php","tilenocache.php","tile","tilenocache")))
		{
			$request->setControllerName('kamap');
			$request->setActionName(str_replace(array("_",".php"),array("",""),$cn));
		}
		else
		{
			$an = $request->getActionName();
			
			if ($request->getControllerName()=="kamap")
			{
				$request->setActionName(str_replace(array("_",".php"),array("",""),$an));
				if (!in_array($request->getActionName(),array("tile","tilenocache")))
				{
					// Only enable gzip for non-image responses:
					ob_start("ob_gzhandler");
				}
			}
			else
			{
				$function = $request->getParam("function");
				$imgAPI = ($request->getControllerName()=="api"&&$conf->imgAPIs->{$function});
				
				if (!($request->getControllerName()=="api"&& $imgAPI))
				{
					// Gzip any responses that are not image-related:
					ob_start("ob_gzhandler");
				}
			}
		}
	}
}
?>