<?php

/**
 * Does some stuff for map layers in MapChat.
 *
 * @class MapChat_Layer
 *
 */
 
class MapChat_Layer
{
	/**
	 * Returns an array of three strings - SQL for inserting into a query to alias the
	 * elements of attributes in a selection from user_drawings for a given layer_id,
	 * a tab-separated string of aliases, and a tab-separated string of field names, which
	 * should be stored as mapchat_fields and mapchat_aliases in the metadata for a layer.
	 *
	 * @param integer $layer_id the id of the layer to retrieve attribute information for.
	 */
	public function UserLayerAttrInfo($layer_id)
	{
		$db = Zend_Registry::get("db");
		$d = Zend_Registry::get("discussion");
		
		$sql = "";
		$aAliases = array();
		$aFields = array();
		
		$aAttr = $db->fetchAssoc("select * from mapchat_user_layer_attributes(?,'".$d->name."')",$layer_id);
		
		foreach ($aAttr as $attr)
		{
			// For now...everything is just going to be text:
			$attr["type"]="text";
			
			$field = MapChat_String::normalize($attr["name"]);
			$sql .= ", attributes[".$attr["index"]."]::".$attr["type"]." as ".$field;
			$aAliases[] = $attr["name"];
			$aFields[] = $field;
		}
		
		return array("sql"=>$sql,"aliases"=>implode("\t",$aAliases),"fields"=>implode("\t",$aFields));
	}
}

?>