<?php

class MapChat_Session
{
	public function startSession($bIgnoreSID=false)
	{
		if (Zend_Registry::get("config")->useCookies || Zend_Session::sessionExists() || Zend_Registry::get("request")->getParam("sid") || $bIgnoreSID)
		{
			// Set key registry variables for MapChat - if they are in the session, use those, otherwise
			// create new instances or use NULL values:
			$ns = MapChat_Session::ns();
			Zend_Registry::set("discussion",isset($ns->discussion)?$ns->discussion:new MapChat_Discussion());
			Zend_Registry::set("me",isset($ns->me)?$ns->me:new MapChat_User());
			
			// Initialize the session variable used for storing client events:
			if (!isset($ns->ClientEvents)) $ns->ClientEvents = array();
			
		}
		else
		{
			throw new MapChat_Exception('Failed to detect session.',1);
		}
		
	}

	public function getSessionInfo()
	{
		$d = Zend_Registry::get("request")->getParam("discussion");
		$me = Zend_Registry::get("me");
		// Will add more here (e.g., info about login status).
		return array(
			"sid" => (Zend_Registry::get("config")->useCookies?false:(Zend_Session::isStarted()?Zend_Session::getId():false)),
			"started" => Zend_Session::isStarted(),
			"auth_status" => Zend_Registry::get("auth")->hasIdentity(), 
			"user_identity" => Zend_Registry::get("auth")->getIdentity(),
			"display_name" => $me?$me->displayName():Zend_Registry::get("auth")->getIdentity(),
			"https_redir" => (Zend_Registry::get("config")->useHTTPS && isset($_SERVER['HTTPS']) && $_SERVER['HTTPS']),
			"load_discussion" => (isset(MapChat_Session::ns()->load_discussion)?MapChat_Session::ns()->load_discussion:false),
		);
	}
	
	/**
	 * Return the MapChat namespace object:
	 *
	 * @param string $index the name assigned to the variable in the session.
	 */
	public function ns()
	{
		return new Zend_Session_Namespace("MapChat");
	}
}
 
?>