<?php

// A class for doing stuff with the MapScript shapeObj:
class MapChat_ShapeObj
{

	/**
	 * Return the geometry in Well Known Text format - basically, this
	 *  is a proxy for the native $oShape->toWkt() method, but corrects
	 *  for the lack of support for multi-point geometries (where it
	 *  instead returns WKT for just the first point found in the
	 *  geometry object).
	 *
	 * @param shapeObj $oShape
	 */
	public function toWkt($oShape)
	{
		if ($oShape->type!=MS_SHAPE_POINT || $oShape->numlines<=1)
		{
			return $oShape->toWkt();
		}
		
		// This appears to be a point shape with more than one 'line'.
		else
		{
			$aWkt = array();
			
			// It seems that each line is actually just a lineObj containing one pointObj:
			for ($i=0;$i<$oShape->numlines;$i++)
			{
				$oPoint = $oShape->line($i)->point(0);
				$aWkt[] = $oPoint->x." ".$oPoint->y;
			}
			
			// Fixed WKT:
			return "MULTIPOINT(".implode(",",$aWkt).")";
		}
	}
}

?>