<?php

/**
 * A class to store and retrieve the version of MapChat (adapted from the Zend_Version library).
 */
final class MapChat_Version
{
    /**
     * MapChat version identification - see compareVersion()
     */
    const VERSION = '2.0.0beta2';

    /**
     * Compare the specified MapChat version string $version
     * with the current MapChat::VERSION of MapChat.
     *
     * @param  string  $version  A version string (e.g. "0.7.1").
     * @return boolean           -1 if the $version is older,
     *                           0 if they are the same,
     *                           and +1 if $version is newer.
     *
     */
    public static function compareVersion($version)
    {
        $version = strtolower($version);
        $version = preg_replace('/(\d)pr(\d?)/', '$1a$2', $version);
        return version_compare($version, strtolower(self::VERSION));
    }
}

?>