CREATE TABLE discussions (
    discussion character varying NOT NULL,
    title character varying NOT NULL,
    description text,
    disabled boolean DEFAULT false NOT NULL,
    moderator character varying,
    mapfile character varying not null,
    config character varying not null,
    srid integer NOT NULL DEFAULT 4326,
    extent geometry,
    creation_date timestamp with time zone DEFAULT current_timestamp
);

ALTER TABLE ONLY discussions
    ADD CONSTRAINT discussions_pkey PRIMARY KEY (discussion);


ALTER TABLE ONLY discussions
    ADD CONSTRAINT discussions_moderator_fkey FOREIGN KEY (moderator) REFERENCES users(username) ON UPDATE CASCADE ON DELETE SET NULL;

ALTER TABLE ONLY discussions
    ADD CONSTRAINT discussions_srid_fkey FOREIGN KEY (srid) REFERENCES spatial_ref_sys(srid) ON UPDATE CASCADE ON DELETE SET NULL;

ALTER TABLE ONLY discussions OWNER to ?dbuser?;