CREATE TABLE groups (
    groupname character varying NOT NULL,
    "password" character varying NOT NULL,
    description character varying NOT NULL,
    moderator character varying,
    is_admin boolean DEFAULT false NOT NULL,
    is_public boolean DEFAULT false NOT NULL,
    can_create_groups boolean DEFAULT false NOT NULL,
    can_create_users boolean DEFAULT false NOT NULL,
    can_create_discussions boolean DEFAULT false NOT NULL,
    can_manage_users boolean DEFAULT false NOT NULL,
    can_manage_groups boolean DEFAULT false NOT NULL,
    can_manage_discussions boolean DEFAULT false NOT NULL,
    creation_date timestamp with time zone DEFAULT now() NOT NULL,
    disabled boolean DEFAULT false NOT NULL
);

ALTER TABLE ONLY groups
    ADD CONSTRAINT groups_pkey PRIMARY KEY (groupname);

ALTER TABLE ONLY groups
    ADD CONSTRAINT tbl_groups_moderator_fkey FOREIGN KEY (moderator) REFERENCES users(username) ON UPDATE CASCADE ON DELETE SET NULL;

ALTER TABLE ONLY groups OWNER to ?dbuser?;