-- The following commands add custom projections useful for displaying Canadian data, which are
-- used by the data distributed with the Chameleon sample map (others can be added as needed):

insert into spatial_ref_sys (srid, auth_name, auth_srid, srtext, proj4text) values (42101, 'EPSG', 42101, 'PROJCS["WGS 84 / LCC Canada",GEOGCS["WGS84",DATUM["WGS_1984",SPHEROID["WGS_1984",6378137,298.257223563]],PRIMEM["Greenwich",0],UNIT["Decimal_Degree",0.0174532925199433]],PROJECTION["Lambert_Conformal_Conic_2SP"],PARAMETER["central_meridian",-95.0],PARAMETER["latitude_of_origin",0],PARAMETER["standard_parallel_1",49.0],PARAMETER["standard_parallel_2",77.0],PARAMETER["false_easting",0.0],PARAMETER["false_northing",-8000000.0],UNIT["Meter",1],AUTHORITY["EPSG","42101"]]','+proj=lcc +ellps=WGS84 +lat_0=0 +lon_0=-95 +lat_1=49 +lat_2=77 +x_0=0 +y_0=-8000000.0 +datum=WGS84 +units=m no_defs');

insert into spatial_ref_sys (srid, auth_name, auth_srid, srtext, proj4text) values (42102, 'EPSG', 42102, 'PROJCS["NAD83 / BC Albers",GEOGCS["NAD83",DATUM["North_American_Datum_1983",SPHEROID["GRS_1980",6378137,298.257222101]],PRIMEM["Greenwich",0],UNIT["Decimal_Degree",0.0174532925199433]],PROJECTION["Albers_conic_equal_area"],PARAMETER["central_meridian",-126.0],PARAMETER["latitude_of_origin",45],PARAMETER["standard_parallel_1",50.0],PARAMETER["standard_parallel_2",58.5],PARAMETER["false_easting",1000000.0],PARAMETER["false_northing",0],UNIT["Meter",1]]','+proj=aea +ellps=GRS80 +lat_0=45 +lon_0=-126.0 +lat_1=50.0 +lat_2=58.5 +x_0=1000000.0 +y_0=0 +datum=NAD83 +units=m no_defs');

insert into spatial_ref_sys (srid, auth_name, auth_srid, srtext, proj4text) values (42304, 'EPSG', 42304, 'PROJCS["NAD83 / NRCan LCC Canada",GEOGCS["NAD83",DATUM["North_American_Datum_1983",SPHEROID["GRS_1980",6378137,298.257222101]],PRIMEM["Greenwich",0],UNIT["Decimal_Degree",0.0174532925199433]],PROJECTION["Lambert_Conformal_Conic_2SP"],PARAMETER["central_meridian",-95.0],PARAMETER["latitude_of_origin",49.0],PARAMETER["standard_parallel_1",49.0],PARAMETER["standard_parallel_2",77.0],PARAMETER["false_easting",0.0],PARAMETER["false_northing",0.0],UNIT["Meter",1],AUTHORITY["EPSG","42304"]]','+proj=lcc +ellps=GRS80 +lat_0=49 +lon_0=-95 +lat_1=49 +lat_2=77 +datum=NAD83 +units=m no_defs');

-- Update the proj4text for nzgd49 datum projections to use the nzgd2kgrid0005.gsb grid shift.  This
-- is making the assumption that the installed proj has the gridshift addon installed with it.
update spatial_ref_sys set proj4text = proj4text||' +nadgrids=nzgd2kgrid0005.gsb' where position('+datum=nzgd49' in proj4text)>0 and position('+nadgrids=nzgd2kgrid0005.gsb' in proj4text)=0;