CREATE TABLE event_types (
    id serial primary key,
    description character varying NOT NULL
);

-- The proper descriptions for these will be added as different types
-- of events are classified - these are just 10 placeholders for now.
insert into event_types (id,description) values (0,'Undefined');
insert into event_types (id,description) values (1,'Discussion Online Status');
insert into event_types (id,description) values (2,'Map Extents Changed');
insert into event_types (id,description) values (3,'UI Log');
insert into event_types (id,description) values (4,'Planner API');
insert into event_types (id,description) values (5,'Map API');
insert into event_types (id,description) values (6,'Discussion Offline Status');
insert into event_types (id,description) values (7,'MessageEdited');
insert into event_types (id,description) values (8,'SpatialTools');
insert into event_types (id,description) values (9,'Chat');
insert into event_types (id,description) values (10,'undefined');

SELECT pg_catalog.setval('event_types_id_seq', 10, true);

ALTER TABLE ONLY event_types OWNER to ?dbuser?;

CREATE TABLE chat_types (
    id serial primary key,
    description character varying NOT NULL
);
-- The proper descriptions for these will be added as different types
-- of chat messages are classified - these are just 10 placeholders for now.
insert into chat_types (id,description) values (1,'Regular Message');
insert into chat_types (id,description) values (2,'undefined');
insert into chat_types (id,description) values (3,'undefined');
insert into chat_types (id,description) values (4,'undefined');
insert into chat_types (id,description) values (5,'undefined');
insert into chat_types (id,description) values (6,'undefined');
insert into chat_types (id,description) values (7,'undefined');
insert into chat_types (id,description) values (8,'undefined');
insert into chat_types (id,description) values (9,'undefined');
insert into chat_types (id,description) values (10,'undefined');

SELECT pg_catalog.setval('chat_types_id_seq', 10, true);

ALTER TABLE ONLY chat_types OWNER to ?dbuser?;

CREATE TABLE plan_types (
    id serial primary key,
    description character varying NOT NULL
);
-- The proper descriptions for these will be added as different types
-- of plans are classified - these are just 10 placeholders for now.
insert into plan_types (id,description) values (1,'Irrigation');
insert into plan_types (id,description) values (2,'undefined');
insert into plan_types (id,description) values (3,'undefined');
insert into plan_types (id,description) values (4,'undefined');
insert into plan_types (id,description) values (5,'undefined');
insert into plan_types (id,description) values (6,'undefined');
insert into plan_types (id,description) values (7,'undefined');
insert into plan_types (id,description) values (8,'undefined');
insert into plan_types (id,description) values (9,'undefined');
insert into plan_types (id,description) values (10,'undefined');

SELECT pg_catalog.setval('plan_types_id_seq', 10, true);

ALTER TABLE ONLY plan_types OWNER to ?dbuser?;

CREATE TABLE shape_types (
    id serial primary key,
    description character varying NOT NULL
);
-- I don't think we need to be concerned with anything more complex than this:
insert into shape_types (id,description) values (1,'POINT');
insert into shape_types (id,description) values (2,'LINE');
insert into shape_types (id,description) values (3,'POLYGON');
insert into shape_types (id,description) values (4,'GEOMETRY');

SELECT pg_catalog.setval('shape_types_id_seq', 4, true);

ALTER TABLE ONLY shape_types OWNER to ?dbuser?;